package com.example.healthcareapp;


import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

import androidx.recyclerview.widget.RecyclerView;


public class MyListAdapter extends RecyclerView.Adapter<MyListAdapter.ViewHolder>{
    private MyListData[] listdata;
    public Context mContext;
    // RecyclerView recyclerView;
    public MyListAdapter(MyListData[] listdata, Context mContext) {
        this.listdata = listdata;
        this.mContext = mContext;
    }
    @Override
    public ViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        LayoutInflater layoutInflater = LayoutInflater.from(parent.getContext());
        View listItem= layoutInflater.inflate(R.layout.list_item, parent, false);
        ViewHolder viewHolder = new ViewHolder(listItem);
        return viewHolder;
    }

    @Override
    public void onBindViewHolder(ViewHolder holder, int position) {
        final MyListData myListData = listdata[position];
        holder.textView.setText(listdata[position].getDescription());
        holder.imageView.setImageResource(listdata[position].getImgId());
        holder.relativeLayout.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                if (myListData.getDescription().equals(SelectionActvity.menus[0])) {
                    System.out.println("Hello1");
                    SelectionActvity.currentMenu=1;
                    SelectionActvity.changeContext(mContext);
                }
                else if (myListData.getDescription().equals(SelectionActvity.menus[1])) {
                    System.out.println("Hello2");
                    SelectionActvity.currentMenu=2;
                    SelectionActvity.changeContext(mContext);
                }
                else if (myListData.getDescription().equals(SelectionActvity.menus[2])) {
                    System.out.println("Hello3");
                    SelectionActvity.currentMenu=3;
                    SelectionActvity.changeContext(mContext);
                }
                else {
                    System.out.println("HELLOOOO");
                    SelectionSecondActvity.changeContext(mContext, myListData.getId());
                }


            }
        });
    }


    @Override
    public int getItemCount() {
        return listdata.length;
    }

    public static class ViewHolder extends RecyclerView.ViewHolder {
        public ImageView imageView;
        public TextView textView;
        public RelativeLayout relativeLayout;
        public ViewHolder(View itemView) {
            super(itemView);
            this.imageView = (ImageView) itemView.findViewById(R.id.imageView);
            this.textView = (TextView) itemView.findViewById(R.id.textView);
            relativeLayout = (RelativeLayout)itemView.findViewById(R.id.relativeLayout);
        }
    }
}