package com.example.healthcareapp;

import android.util.Log;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.Socket;
import java.util.Currency;
import java.util.concurrent.atomic.AtomicReferenceArray;

public class ServerConnect  extends Thread {

    Socket socket;
    InputStream is;
    InputStreamReader isr;
    BufferedReader br;
    PrintWriter out;
    boolean connected = false;

    @Override
    public void run() {
        stateMachine();
    }

    //State can be changed by changing the MainActivity.state variable, and determines how the client interacts with the server
    public void stateMachine () {
        String currentState;
        do {
            currentState = MainActivity.state;
            switch(currentState) {
                case "WAITING":
                    break;
                case "LOGIN":
                    login();
                    break;
                case "NOCONNECT":
                    connect();
                    break;
                case "REGISTER":
                    register();
                    break;
                case "APPOINTMENT":
                    appointment();
                    break;
                case "PRIVACY":
                    privacy();
                    break;
                case "READY":
                    ready();
                    break;
                default:
            }
        } while (true);
    }

    public void connect () {
        try {
            System.out.println("Attempting to connect");
            //top = local test, bottom = server test
            socket = new Socket("10.0.2.2",3030);
//            socket = new Socket("18.206.246.77",3030);
            is = socket.getInputStream();
            isr = new InputStreamReader(is);
            br = new BufferedReader(isr);
            out = new PrintWriter(socket.getOutputStream(),true);
            MainActivity.state = "WAITING";
            System.out.println("Attempting to connect - end");
        } catch (Exception e) {
        }
    }

    public void login () {
        out.println("LOGIN");
        out.println(MainActivity.userN);
        out.println(MainActivity.passW);
        String response;
        String role;
        try {
            response  = br.readLine();
            if (response.equals("LOGINTRUE")) {
                int id = br.read();
                br.readLine();
                role = br.readLine();
                MainActivity.userID = id;
                MainActivity.role = role;
                QuestionActivity.privacySettings = QuestionActivity.convertToBoolean(br.readLine());
                if (br.readLine().equals("TRUE")) {
                    MainActivity.ready = true;
                }
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
        appointmentCheck();
        MainActivity.state = "WAITING";
    }

    public void ready() {
        out.println("READY");
        String s = "FALSE";
        if (MainActivity.ready) {
            s = "TRUE";
        }
        out.println(s);
        MainActivity.state = "WAITING";
        try {
            if (br.readLine().equals("NEGOTIATE")) {
                QuestionActivity.privacySettings = QuestionActivity.convertToBoolean(br.readLine());
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public void privacy() {
        out.println("PRIVACY");
        out.println(QuestionActivity.convertToString(QuestionActivity.privacySettings));
        MainActivity.state = "WAITING";
        try {
            if (br.readLine().equals("NEGOTIATE")) {
                QuestionActivity.privacySettings = QuestionActivity.convertToBoolean(br.readLine());
            }        } catch (IOException e) {
            e.printStackTrace();
        }
    }


    void register () {
        out.println("REGISTER");
        out.println(RegisterActivity.newUser);
        out.println(RegisterActivity.newPassw);
        out.println(RegisterActivity.newEmail);
        if (RegisterActivity.role = true) {
            out.println("Caretaker");

        } else {
            out.println("Patient");
        }
        String response;
        try {
            response  = br.readLine();
            if (response.equals("REGISTERTRUE")) {
                MainActivity.controlKey = true;
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
        MainActivity.state = "WAITING";
    }

    void appointment() {
        out.println("APPOINTMENT");
        out.println(ScheduleActivity.vDateTime);
        String response;
        try {
            response  = br.readLine();
        } catch (IOException e) {
            e.printStackTrace();
        }
        MainActivity.state = "WAITING";
    }

    void appointmentCheck() {
        out.println("APPOINTMENTCHECK");
        try {
            String temp = br.readLine();
            if (temp.equals("START")) {
                ScheduleActivity.dates = "";
                temp = br.readLine();
                while (!temp.equals("END")) {
                    ScheduleActivity.dates = ScheduleActivity.dates + "&" +temp;
                    temp = br.readLine();
                }
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

}

